package com.muzhi.lz.entity;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.util.Date;

@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "Employee_lz律政在职人员数据", description = "最终展示表")
public class EmployeeLz {

    @ApiModelProperty(value = "员工ID")
    private String id;

    @ApiModelProperty(value = "姓名")
    private String sys00Name;

    @ApiModelProperty(value = "职位")
    private String sys00Position;

    @ApiModelProperty(value = "入职时间")
    private Date sys00ConfirmJoinTime;

    @ApiModelProperty(value = "员工类型")
    private Integer sys01EmployeeType;

    @ApiModelProperty(value = "员工状态")
    private Integer sys01EmployeeStatus;

    @ApiModelProperty(value = "性别（0：男；1：女）")
    private Integer sys02SexType;



    @ApiModelProperty(value = "部门id1")
    private String bmid1;

    @ApiModelProperty(value = "部门名称1")
    private String bmmc1;

    @ApiModelProperty(value = "部门id2")
    private String bmid2;

    @ApiModelProperty(value = "部门名称2")
    private String bmmc2;

    @ApiModelProperty(value = "部门id3")
    private String bmid3;

    @ApiModelProperty(value = "部门名称3")
    private String bmmc3;

    @ApiModelProperty(value = "部门id4")
    private String bmid4;

    @ApiModelProperty(value = "部门名称4")
    private String bmmc4;

    @ApiModelProperty(value = "部门id5")
    private String bmid5;

    @ApiModelProperty(value = "部门名称5")
    private String bmmc5;

    @ApiModelProperty(value = "部门id6")
    private String bmid6;

    @ApiModelProperty(value = "部门名称6")
    private String bmmc6;

    @ApiModelProperty(value = "部门id7")
    private String bmid7;

    @ApiModelProperty(value = "部门名称7")
    private String bmmc7;

    @ApiModelProperty(value = "部门id8")
    private String bmid8;

    @ApiModelProperty(value = "部门名称8")
    private String bmmc8;

    @ApiModelProperty(value = "部门id9")
    private String bmid9;

    @ApiModelProperty(value = "部门名称9")
    private String bmmc9;
}
