package com.muzhi.lz.APITest;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.dingtalk.api.DefaultDingTalkClient;
import com.dingtalk.api.DingTalkClient;
import com.dingtalk.api.request.OapiSmartworkHrmEmployeeListdimissionRequest;
import com.dingtalk.api.request.OapiV2DepartmentGetRequest;
import com.dingtalk.api.request.OapiV2DepartmentListparentbyuserRequest;
import com.dingtalk.api.response.OapiSmartworkHrmEmployeeListdimissionResponse;
import com.dingtalk.api.response.OapiV2DepartmentGetResponse;
import com.dingtalk.api.response.OapiV2DepartmentListparentbyuserResponse;
import com.muzhi.lz.entity.EmployeeLzCopy;
import com.muzhi.lz.entity.EmployeeLzRuzhiCopy;
import com.muzhi.lz.entity.Test1Copy;
import com.muzhi.lz.mapper.EmployeeLzRuzhiCopyMapper;
import com.muzhi.lz.mapper.EmployeeLzRuzhiMapper;
import com.muzhi.lz.mapper.Test1CopyMapper;
import com.muzhi.lz.mapper.Test1Mapper;
import com.muzhi.lz.service.DingAccessTokenService;
import com.taobao.api.ApiException;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.junit.jupiter.api.Test;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

@SpringBootTest
public class Test1 {

    @Autowired
    private DingAccessTokenService dingAccessTokenService;

    @Autowired
    private Test1Mapper test1Mapper;
    @Autowired
    private Test1CopyMapper test1CopyMapper;

    //律政入职人员
    @Autowired
    private EmployeeLzRuzhiMapper employeeLzRuzhiMapper;
    @Autowired
    private EmployeeLzRuzhiCopyMapper employeeLzRuzhiCopyMapper;

//    @Test
//    public void list(){
//
//        //***获取指定用户的所有父部门列表
//        String bumen111 = null;
//        try {
//            DingTalkClient client111 = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/v2/department/listparentbyuser");
//            OapiV2DepartmentListparentbyuserRequest req111 = new OapiV2DepartmentListparentbyuserRequest();
//
//            //传入用户id
//            req111.setUserid("1606903117970600");
//
//            OapiV2DepartmentListparentbyuserResponse rsp111 = client111.execute(req111, dingAccessTokenService.getAccessToken());
//            bumen111 = rsp111.getBody();
//            System.out.println(rsp111.getBody());
//        } catch (ApiException e) {
//            e.printStackTrace();
//        }
//
//        JSONObject jsonObject = JSON.parseObject(bumen111);
//        JSONObject result = jsonObject.getJSONObject("result");
//        JSONArray parent_list = result.getJSONArray("parent_list");
//        System.out.println("初步解析处理：" + parent_list);
//
//        for (int a = 0; a<parent_list.size(); a++){
//            JSONArray parent_dept_id_list = parent_list.getJSONObject(a).getJSONArray("parent_dept_id_list");
//            System.out.println("多部门列表解析：" + parent_dept_id_list);
//
//            //获取部门详情（主要用于获取部门名称）
//            for (int b = 0; b<parent_dept_id_list.size(); b++){
//                String bmid111 = parent_dept_id_list.getString(b);
//                long bmid222 = Long.parseLong(bmid111);
//                System.out.println("最终解析的每个独立的部门id：" + bmid111);
//
//                System.out.println("部门分组长度：" + parent_dept_id_list.size());
//
//                String bumenXQ = null;
//                try {
//                    DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/v2/department/get");
//                    OapiV2DepartmentGetRequest req = new OapiV2DepartmentGetRequest();
//
//                    //部门id
//                    req.setDeptId(bmid222);
//
//                    OapiV2DepartmentGetResponse rsp = client.execute(req, dingAccessTokenService.getAccessToken());
//                    bumenXQ = rsp.getBody();
//                    System.out.println(rsp.getBody());
//                } catch (ApiException e) {
//                    e.printStackTrace();
//                }
//
//                //TODO 解析出来部门名称
//                JSONObject jsonObject1 = JSON.parseObject(bumenXQ);
//                System.out.println("初步解析处理（部门详情）：" + jsonObject1);
//
//                JSONObject result1 = jsonObject1.getJSONObject("result");
//                String BMname = result1.getString("name");
//                System.out.println("部门名称：" + BMname);
//
//                //TODO 每组部门id都插入一条员工信息到数据库
//
//
//            }
//            System.out.println("-------------------------分组分割线-------------------------");
//        }
//    }
//
//    @Test
//    public void lizhi(){
//        //***获取员工的离职信息
//        String lizhi = null;
//        try {
//            DingTalkClient clientLZ = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/smartwork/hrm/employee/listdimission");
//            OapiSmartworkHrmEmployeeListdimissionRequest reqLZ = new OapiSmartworkHrmEmployeeListdimissionRequest();
//
//            //离职员工id
//            reqLZ.setUseridList("1606903117970600");
//
//            OapiSmartworkHrmEmployeeListdimissionResponse rspLZ = clientLZ.execute(reqLZ, dingAccessTokenService.getAccessToken());
//            lizhi = rspLZ.getBody();
//            System.out.println(rspLZ.getBody());
//        } catch (ApiException e) {
//            e.printStackTrace();
//        }
//
//        JSONObject jsonObjectLizhi;
//        JSONArray resultLizhi;
//        String lastWorkDay = null;
//        String main_dept_id = null;
//        Date date1 = null;
//
//        try {
//            jsonObjectLizhi = JSON.parseObject(lizhi);
//            resultLizhi = jsonObjectLizhi.getJSONArray("result");
//
//            lastWorkDay = resultLizhi.getJSONObject(0).getString("last_work_day");
//
//            main_dept_id = resultLizhi.getJSONObject(0).getString("main_dept_id");
//
//            //时间戳转为日期格式
//            SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss"); //24小时制
//            String timeStamp = lastWorkDay;
//            long time = Long.parseLong(timeStamp);
//            Date date = new Date();
//            date.setTime(time);
//            String timeLizhi = simpleDateFormat.format(date);
//            System.out.println("时间戳转日期格式：" + timeLizhi);
//
//            //String型日期转换成Date型
//            date1 = simpleDateFormat.parse(timeLizhi);
//
//        }catch (Exception e){
//            e.printStackTrace();
//        }
//
//        System.out.println("lastWorkDay：" + lastWorkDay);
//        System.out.println("main_dept_id：" + main_dept_id);
//        System.out.println("Date类型最后工作日期：" + date1);
//    }
//
//    @Test
//    public void copy(){
//
//        //有数据的表
//        com.muzhi.lz.entity.Test1Copy test1Copy = new com.muzhi.lz.entity.Test1Copy();
//
//        QueryWrapper<com.muzhi.lz.entity.Test1Copy> test1CopyQueryWrapper = new QueryWrapper<>();
//        List<com.muzhi.lz.entity.Test1Copy> test1CopyList = test1CopyMapper.selectList(test1CopyQueryWrapper);
//        System.out.println("test1CopyList" + test1CopyList);
//
//
//        //无数据的表
//        com.muzhi.lz.entity.Test1 test1 = new com.muzhi.lz.entity.Test1();
//
//        QueryWrapper<com.muzhi.lz.entity.Test1> test1QueryWrapper = new QueryWrapper<>();
//        List<com.muzhi.lz.entity.Test1> test1List = test1Mapper.selectList(test1QueryWrapper);
//        System.out.println("test1List" + test1List);
//
//
//
//        //将有数据的表数据插入无数据的表对应的字段中
//        for (int a = 0; a<test1CopyList.size(); a++){
//            test1.setId(test1CopyList.get(a).getId());
//            test1.setName(test1CopyList.get(a).getName());
//            test1.setSex(test1CopyList.get(a).getSex());
//            test1.setTeacher(test1CopyList.get(a).getTeacher());
//            test1Mapper.insert(test1);
//        }
//    }

    @Test
    public void panduan(){
        /*判断数据库入职表中是否存在该人员的id*/
//        String id111 = null;
        Integer id111 = 0;
        try {
            QueryWrapper<EmployeeLzRuzhiCopy> queryWrapper = new QueryWrapper<>();
            queryWrapper.select("id").eq("id", "16359029338988172");

            Integer integer = employeeLzRuzhiCopyMapper.selectCount(queryWrapper);
            System.out.println("查询当前人员的id在数据库中是否存在，返回数据条数：" + integer);
//            id111 = employeeLzRuzhiCopy1.getId();
            id111 = integer;
            System.out.println("查询数据库入职表中的存在人员的id条数：" + id111);
        }catch (Exception e){
            e.printStackTrace();
        }
        /*判断数据库入职表中是否存在该人员的id*/

        //【***如果入职首次同步表中不存在律政架构中当前循环的该人员id，将该部门及人员信息插入当前的入职copy表***】
        if (id111==null || id111==0){
            System.out.println("数据库不存在该人员，插入！");
        }else {
            System.out.println("数据库中该人员已存在，不执行任何操作！");
        }
    }
}